;Lab5
;Andrew Fowler
;Damian Szmulewicz Section: 3276
; SCI interface


;*****************************************************************



		.global		_c_int00

data_sect	.set		0xa000			;constant that is actually the starting addr of .data section
bss_sect	.set		0xb000			;constant that is actually the starting addr of .bss section
GPAMUX1 	.set 		0x6F86
GPAMUX2 	.set 		0x6F87
WDCR		.set		0x7029
GPADIR 		.set		0x6F8A
GPASET		.set		0x6FC2
GPADAT 		.set 		0x6FC0
SCICCR		.set		0x7750
LSPCLK		.set		0x701B
SCIBAUD		.set		0x7753
SCICTL1		.set		0X7051
SCICTL2 	.SET		0x7754
SCITXBUF	.set		0x7059
CHARSTART	.set		char
GPATOGGLE 	.set 		0x6FC6
;*****************************************************************

		.data				;data section, see the command linker file, this puts the 
							;following data defined below in a block of internal SRAM
							;starting at 0xA000. 
counter .word    	0h  	;define word, two bytes placed in memory stating in the data section     
num4    .word    	01234h	;define word, two bytes placed in memory
char    .byte    	'E' 	;define string, ASCII characters placed in memory as WORDS!
        .byte    	'E'
        .byte    	'L'
        .byte    	'4'
        .byte    	'7'
        .byte    	'4'
        .byte    	'4'
        .byte		"0123"	;here is another way to specify a string of WORDS!
	    .word		0xfab4	;another way to specify a hex number (WORD)
val1	.word		32		;places 32 decimal (20 hex) in memory (WORD) at label val1 at load-time
val2	.word		512		;places 512 decimal(200 hex) in memory (WORD) at label val2 at load-time
val3	.long		0x12345678	;places two words in memory (lower word/lower addr, big endian)	
	    		
	    					;.BSS SECTION is used to reserve space in SRAM for run-time results.
	    					; See the command linker file, the starting address is 0xB000
	    .bss		results,3	;reserves three words at label 'results' in the .bss section	
	    .bss		sum,1		;reserves one word at label 'sum' in the .bss section
	    
								;.global directive lets you to see the assigned addresses in map file.	    
		.global		num1,num2,num3,num3,num4,counter,char,val1,val2,val3,results,sum 
		
;****************** Part A ***********************
		.text					; Program section, see the command linker file, program code 
								; should be placed in the text section which starts at 0x9000
						
_c_int00:						; This label tells the linker where the entry (starting) point for 
	EALLOW 						; Allow access to protected registers
	SETC 	OBJMODE 			; Allow 32 bit mov instructions
	SETC 	VMAP			; 
								; WDCR is watchdog timer control register
								; In constants section need to set WDCR=0x7029
	MOV 	AL,#1101000b 	; Disable the watchdog timer.
								; Must have 101 in bits 5, 4, 3 for
								; any writes to WDCR. 1 in bit 6
								; disables watchdog
	MOV 	AR1,#WDCR
	MOV		*AR1, AL 		; Disables watchdog timer
	
	MOV		AR0, #char
		
;*******************************************
	; Initializations
		
	MOV		AR1, #GPAMUX2		; Sets to inputs/outputs
	MOV		AL, #0x000
	MOV		*AR1, AL
	
	MOV		AR1, #GPADIR+1		; Sets the pins to outputs
	MOV		AH, #111111b	
	MOV		*AR1, AH	
	
;*************************************************
	;LCD INITIALIZATIONS
	MOV		AR1, #GPADAT+1 		; Do not use AR1 again while LCD writing
	
	MOV		AH, #111100b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV 	AH, #011100b
	MOV		*AR1, AH
	LC		LCDDELAY

	MOV 	AH, #111100b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV 	AH, #011100b
	MOV		*AR1, AH
	LC		LCDDELAY

	MOV 	AH, #111100b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV 	AH, #011100b
	MOV		*AR1, AH
	LC		LCDDELAY
	
	MOV 	AH, #110100b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV 	AH, #010100b
	MOV		*AR1, AH
	LC		LCDDELAY

	MOV 	AH, #110100b  	; 2 lines
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV 	AH, #010100b  	; 2 lines
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #111000b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #011000b
	MOV		*AR1, AH
	LC		LCDDELAY
	
	MOV 	AH, #110000b 	; Display on; Cursor on, blink on
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV 	AH, #010000b 	; Display on; Cursor on, blink on
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #111111b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #011111b
	MOV		*AR1, AH
	LC		LCDDELAY
	
	MOV 	AH, #110100b 	;Clear SCreen, Cursor home
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV 	AH, #010100b 	;Clear SCreen, Cursor home
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #110001b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #010001b
	MOV		*AR1, AH
	LC		LCDDELAY
	
	;<INITIALIZATION COMPLETE>;
	
;***********************************************

	; Program
	
	LC LCD_STRING
END	B	END, UNC

	
	
	
	
		
;*************************************************************************		
	; Sub Routines
	
		
		
LCD_STRING:
		MOV		AH, #0
		MOV		AR0, #CHARSTART	; Data location where the string is stored
loopL	MOV		AL, *AR0		; Mov Char to AL
		B		LCD_CHAR, NEQ	; If not null write the char
		LRET					; All done if there was a null char
		
LCD_CHAR:
		MOV		AL, *AR0	; points to the CHAR
		AND		AL, #1111b	; only gets the first 4 chars
		MOV		*AR1, AL	; Writes to GPADAT the first nibble
		
		MOV		AL, *AR0	; points to the GPADAT
		LSR		AL, 4		; only gets the last 4 chars
		AND		AL, #1111b	; deletes everything else
		MOV		*AR1, AL	; Moves 00 CHAR to LCD to write it	
		
		INC		AR0			;  updates to enxt char		
		B		loopL, UNC	; Goes back to string function		
		
LCDDELAY:
		MOV 	AL, #1
loopd	DEC 	AL
		nop
		nop
		nop
		B	loopd, NEQ
		LRET
		
		
		
		
		
		
		
	
		
